"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var react_1 = __importStar(require("react"));
var useBem_1 = __importDefault(require("@steroidsjs/core/hooks/useBem"));
var ChatInput_1 = __importDefault(require("./views/ChatInput"));
var BubblesDateGroup_1 = __importDefault(require("./views/BubblesDateGroup"));
function ChatView(props) {
    var bem = (0, useBem_1["default"])('ChatView');
    var wrapperRef = (0, react_1.useRef)(null);
    var contentRef = (0, react_1.useRef)(null);
    var prevContentHeightRef = (0, react_1.useRef)(null);
    (0, react_1.useEffect)(function () {
        var wrapperHeight = wrapperRef.current.clientHeight;
        var contentHeight = contentRef.current.clientHeight;
        var wrapperScrollTop = wrapperRef.current.scrollTop;
        if (!prevContentHeightRef.current || wrapperScrollTop === prevContentHeightRef.current - wrapperHeight) {
            wrapperRef.current.scrollTo({
                top: contentHeight - wrapperHeight,
                left: 0,
                behavior: prevContentHeightRef.current ? 'smooth' : 'auto'
            });
        }
        prevContentHeightRef.current = contentHeight;
    }, [props.groupedMessagesByDates]);
    var renderChatScreen = (0, react_1.useCallback)(function () { return (react_1["default"].createElement("div", { className: bem.element('screen') },
        react_1["default"].createElement("div", { className: bem.element('wrapper'), ref: wrapperRef },
            react_1["default"].createElement("div", { className: bem.element('content'), ref: contentRef }, Object.entries(props.groupedMessagesByDates)
                .map(function (_a) {
                var date = _a[0], groupedMessages = _a[1];
                return (react_1["default"].createElement(BubblesDateGroup_1["default"], { key: date, date: date, groupedMessages: groupedMessages, currentUser: props.currentUser }));
            }))))); }, [bem, props.groupedMessagesByDates, props.currentUser]);
    return (react_1["default"].createElement("div", { className: bem.block() },
        renderChatScreen(),
        react_1["default"].createElement(ChatInput_1["default"], { chatId: props.chatId, onSendMessage: props.onSendMessage })));
}
exports["default"] = ChatView;
